/***********************************************************************
 *              GENERIC 16bit Realtime Task Monitor                    *
 *      Copyright 1991 - 1998 by Fritz       Allrights Reserved.       *
 *  -----------------------------------------------------------------  *
 *              fdmPUVXeʃCN[ht@C             *
 ***********************************************************************/

/* =================================================================== *
   ʂ̒`
/* =================================================================== */

    #define STS_NML             0           /* Status = Normal      */
    #define STS_ERR            -1           /* Status = Error       */
    #define STS_NIL             0           /* Status = None (INT)  */
    #define STS_NUL          NULL           /* Status = None (CHAR) */

#ifndef TRUE
    #define TRUE                1           /* TRUE                 */
    #define FALSE               0           /* FALSE                */
#endif

/* =================================================================== *
   Z}tH얽
/* =================================================================== */

    #define SEM_LOCK            1           /* ̫  (҂) */
    #define SEM_UNLOCK          2           /* ̫             */
    #define SEM_NWLOCK          3           /* ̫  (҂Ȃ) */
    #define SEM_LOAD            4           /* ̫ 擾        */

/* =================================================================== *
   IPC_PRECV 얽
/* =================================================================== */

    #define PRECV_NOWAIT        0           /*  IPC_PRECV No Wait */
    #define PRECV_WAIT          1           /*  IPC_PRECV Wait 	*/

/* =================================================================== *
   TimeSlice
/* =================================================================== */

    #define TMC_TMCLON          1           /* Time Slice Start     */
    #define TMC_TMCLOF          0           /* Time Slice Stop      */

/* =================================================================== *
   vZX
/* =================================================================== */

    #define TSS_RUN           0x0000         /* Task is READY        */
    #define TSS_WAIT_1        0x0001         /* IPC_POSTŎgp       */
    #define TSS_WAIT_2        0x0002         /* RESERVED             */
    #define TSS_WAIT_3        0x0004         /* RESERVED             */
    #define TSS_WAIT_4        0x0008         /* RESERVED             */
    #define TSS_WAIT_5        0x0010         /* RESERVED             */
    #define TSS_WAIT_6        0x0020         /* RESERVED             */
    #define TSS_WAIT_7        0x0040         /* RESERVED             */
    #define TSS_WAIT_8        0x0080         /* RESERVED             */
    #define TSS_WAIT_9        0x0100         /* USR 1                */
    #define TSS_WAIT_A        0x0200         /* USR 2                */
    #define TSS_WAIT_B        0x0400         /* USR 3                */
    #define TSS_WAIT_C        0x0800         /* USR 4                */
    #define TSS_WAIT_D        0x1000         /* USR 5                */
    #define TSS_WAIT_E        0x2000         /* USR 6                */
    #define TSS_WAIT_F        0x4000         /* USR 7                */
    #define TSS_WAIT_G        0x8000         /* USR 8                */

/* =================================================================== *
   modeget֐ԋpe[u
/* =================================================================== */

    #define NMAC_PC9801     1               /* @ PC_9801     */
    #define NMAC_PCAT       2               /* @ IBM PC_AT   */
    #define KNL_IDLE        0               /* ُ ~      */
    #define KNL_ACTIVE      1               /* ُ ʏ퓮쒆  */
    #define KNL_EXIT        2               /* ُ I  */

    struct _modgetbuf {
        int     nmacid ;                    /* @             */
        int     ntmslice ;                  /* ѽײL          */
        int     nkernel ;                   /* ٓ         */
        int     nmaxtss ;                   /* o^\ő۾  */
        int     nmaxpost ;                  /* o^\őPOST   */
        int     nmaxexp ;                   /* o^\őEXPORT */
        int     nmaxtimer ;                 /* o^\őϰ   */
        int     nmaxsemafo ;                /* o^\ő̫   */
    } ;

/* =================================================================== *
   TimerGet֐ԋpe[u
/* =================================================================== */

    struct _tmgetinf {
        int     nkyT ;                      /*  M IPC_POSTL[ */
        int     nCdT ;                      /*  M IPC_POST */
        int     norg ;                      /*  ѱĒliۑpj  */
        int     ncur ;                      /*  ϰl          */
    } ;

/* =================================================================== *
   getpinfo֐ԋpe[u
/* =================================================================== */

    struct _pinfo {
        int     nptyp ;                     /* ۾            */
        long    nstack ;                    /* ڰѱڽ        */
        int     npid ;                      /* PID                  */
        int     psp ;                       /* PSP                  */
        long    dta ;                       /* DTA                  */
    } ;

/* =================================================================== *
   ee[u TYPEDEF l
/* =================================================================== */

    typedef struct _pinfo       GEN_PRCINF ;
    typedef struct _tmgetinf    GEN_TIMINF ;
    typedef struct _modgetbuf   GEN_MODINF ;

/* =================================================================== *
   ֐vg^Cv錾
/* =================================================================== */

int         CreateThread( char far *, char far *, int ) ;
int         _checkstay  ( void ) ;
int         getpid      ( void ) ;
int         getstate    ( int ) ;
int         setstate    ( int, int ) ;
int         kill        ( int  ) ;
int         export      ( int, char far * ) ;
int         unexport    ( int  ) ;
int         ipc_pinit   ( int  ) ;
int         ipc_post    ( int, int ) ;
int         ipc_precv   ( int, int, int ) ;
int         TimerSet    ( int, int, int, int ) ;
int         TimerGet    ( int, struct _tmgetinf far * ) ;
int         ipc_semget  ( int, int ) ;
int         ipc_semop   ( int, int ) ;
int         modeget     ( struct _modgetbuf far * ) ;
int         getpinfo    ( int, struct _pinfo far * ) ;
int         kbd_scan    ( void ) ;
int         kbd_input   ( void ) ;
void        sleep       ( int  ) ;
void        dispatch    ( void ) ;
void        kernel_start( void ) ;
void        kernel_quit ( void ) ;
void        TimeSlice   ( int  ) ;
char far *  import      ( int  ) ;
char far *  alloca      ( int  ) ;

