/* ========================================================================== *
 *  Generic-16 Multi Task Kernel                                              *
 *  Sample program for Generic-16 API sample                                  *
 * ========================================================================== */

#include        <stdio.h>
#include        "gen16.h"
#include        "test03.h"

    int proc01_pid ;
    int proc02_pid ;

/*****************************************************************************
 * main : C[`                                                     *
 * TvvÕX^[g|Cg                                      *
 *****************************************************************************/

int main(int nargc, char *pargv[] )
{
    int     nidx, npid ;
    int     nstchk ;
    char   *p ;

/* -------------------------------------------------------------------- *
   
 * -------------------------------------------------------------------- */

    printf( "Generic Multi task kernel sample program No.003\n" ) ;

/* -------------------------------------------------------------------- *
   Generic-16 J[l풓胋[`
   J[l풓̏ꍇ풓čēx`FbNBRNɎs
   ꍇ́AG[bZ[W\ĈُIB܂AɃJ[l
   풓Ăꍇ̓tO(nstchk)ݒ肵Č듮hB
 * -------------------------------------------------------------------- */

    nstchk = FALSE ;

    for ( nidx=0; nidx<RETRY_MAX; nidx++ )
    {
        if ( _checkstay() )
        {   
            printf( "Generic-16 J[l풓܂\n" ) ;
            printf( "Kernel = %s\n", GEN16_KERNEL ) ;
            system( GEN16_KERNEL ) ;
            nstchk = TRUE ;
        } else {
            printf( "Generic-16 J[l̏풓mF܂\n" ) ;
            break ;
        }
    }
    if ( nidx == RETRY_MAX )
    {
        printf( "Generic-16 J[l풓ł܂ł\n" ) ;
        printf( "fBNg\`FbNċNȂĂ\n" ) ;
        exit(0);
    }

/* -------------------------------------------------------------------- *
   vZXo^[`
   vZX̃X^bN̈抄蓖ẮAK alloca֐gpĂB
 * -------------------------------------------------------------------- */

    p = alloca( 8192*2 ) ;

    if ( p == NULL )
    {
        printf( "X^bN̈悪mۂł܂\n" ) ;
        goto QUIT ;
    }

    proc01_pid = CreateThread( (char far *)test_proc01, p+2048, 2048 ) ;
    proc02_pid = CreateThread( (char far *)test_proc02, p+4096, 2048 ) ;
    
    printf( "Thread 1 Created pid = %d\n", proc01_pid ) ;
    printf( "Thread 2 Created pid = %d\n", proc02_pid ) ;

    printf( "}`^XNJ[l̐Jn܂\n" ) ;

    kernel_start() ;

    printf( "}`^XNJ[l̐I܂\n" ) ;
    printf( "eXgvOI܂\n" ) ;

/* -------------------------------------------------------------------- *
   Generic-16 J[l풓[`
   {vOɂăJ[lNĂ΁AJ[l̏풓
   B
 * -------------------------------------------------------------------- */

QUIT:
    if ( nstchk != FALSE )
    {
        printf( "Generic-16J[l̏풓܂\n" ) ;
        system( GEN16_KERNEL ) ;
    }

}

/*****************************************************************************
 * test_proc01 : eXgpvZXP                                          *
 *                                                                           *
 *****************************************************************************/

int test_proc01( void )
{
	static char  data[256] ;

	printf( "vZXPN܂\n" ) ;
	sleep(10) ;

	strcpy( data, "this is the test" ) ;


	dispatch() ;

	printf( "vZXP: bZ[W𑗐M܂, data=%p\n", data ) ;

	msgsnd( 10, strlen(data), data ) ;  

	while (1)
	{
		sleep(10) ;
	}
}

/*****************************************************************************
 * test_proc02 : eXgpvZXQ                                          *
 *                                                                           *
 *****************************************************************************/

int test_proc02( void )
{
	int		sts ;
	char	buf[256] ;

	printf( "PROC2: vZXQN܂\n" ) ;
	sleep(10) ;

	printf( "PROC2: M[vɓ܂  buf=%p\n", buf ) ;
	memset( buf, 0, sizeof(buf) ) ;

	sts = msgrcv( 10, 256, buf ) ;
	printf( "PROC2: Mf[^ = %s, sts = %d\n", buf, sts ) ;

	keywait( "PROC2: TvvOI܂", 'e' ) ;
    kernel_quit() ;
}

/*****************************************************************************
 * keywait : L[͑҂֐                                                *
 *                                                                           *
 *****************************************************************************/

int keywait( char *msg, int wait )
{
  printf( "%s\n", msg ) ;

  if ( wait != 0 )
  {
  	printf( "'%c'L[Ă\n", wait ) ;
  } else {
    printf( "ǂꂩL[Ă\n" ) ;
  }

  while ( 1 )
  {
	while( kbd_scan() ) ;
	while(!kbd_scan() ) dispatch() ;
	
	if ( wait != 0 )
	{
	  if ( kbd_input() == wait )
	  {
	    break ;
	  }
	} else {
      break ;
	}
  }
  return STS_NML ;
}


