; ***********************************************************************
; *				GENERIC 16bit Realtime Task Monitor						*
; *	    Copyright 1991 - 1998 by Fritz Allrights Reserved.       		*
; *  -----------------------------------------------------------------  *
; *   Generic 16-bit Multi Task Kernel VXeCN[ht@C     *
; *                                                                     *
; ***********************************************************************

; =====================================================================
;	`[jO\
; =====================================================================

;	PC_9801			equ		0
;	IBM_PCAT		equ		1

if PC_9801
	VECT_TM			equ		01ch	; Kernelϰ荞޸
endif

if IBM_PCAT
	VECT_TM			equ		08h		; Kernelϰ荞޸
endif

	VECT_NO			equ		0F0h	; KernelظĎt޸
	MAX_TSS			equ		32		; ő۾
	MAX_PTSS		equ		32		; x޲ނł۾ő吔
	MAX_POST		equ		32		; IPC_POSTL[ő吔
	MAX_EXPORT		equ		255		; EXPORTްްő吔
	MAX_TIMER		equ		32		; ϰčő吔
	MAX_SEMAFO		equ		32		; ̫Ǘðٍő吔
	MAX_MESG		equ	   192		; ipc message que ő吔
	MAX_MSGCHUNK	equ	  8192		; ipc message que ݸ

; =====================================================================
;	VXeR[ԍ
; =====================================================================

	QUIT_REQ		equ		01h
	THREAD_REQ		equ		02h
	DISPATCH_REQ	equ		03h
	GETPID_REQ		equ		04h
	START_REQ		equ		05h
	KQUIT_REQ		equ		06h
	GETSTS_REQ		equ		07h
	SETSTS_REQ		equ		08h
	IPCPINIT_REQ	equ		09h
	IPCPOST_REQ		equ		0Ah	
	IPCPRECV_REQ	equ		0Bh
	KILL_REQ		equ		0Ch
	EXPORT_REQ		equ		0Dh
	IMPORT_REQ		equ		0Eh
	UNEXPORT_REQ	equ		0Fh
	SETTIMER_REQ	equ		10h
	GETTIMER_REQ	equ		11h
	SEMGET_REQ		equ		12h
	SEMOPE_REQ		equ		13h
	SLEEP_REQ		equ		14h
	MODGET_REQ		equ		15h
	TMSLICE_REQ		equ		16h
	GETPINF_REQ		equ		17h
	KILLT_REQ       equ     18h
	MSGGET_REQ		equ		19h
	MSGSND_REQ		equ		1ah
	MSGRCV_REQ		equ		1bh
	ADDON_REQ		equ		1ch
	ADDOFF_REQ		equ		1dh
	ADDGET_REQ		equ		1eh

; =====================================================================
;	vZXubN
; =====================================================================

	TSS_RUN			equ		 0
	TSS_WAIT_1		equ		 1		; IPC_POSTŎgp
	TSS_WAIT_2		equ		 2		; killނŎEƂ׸
	TSS_WAIT_3		equ		 4		; IPC_MESSAGEŎgp
	TSS_WAIT_4		equ		 8		; RESERVED
	TSS_WAIT_5		equ		10h		; RESERVED
	TSS_WAIT_6		equ		20h		; RESERVED
	TSS_WAIT_7		equ		40h		; RESERVED
	TSS_WAIT_8		equ		80h		; RESERVED
	TSS_WAIT_9		equ	   100h		; USR 1
	TSS_WAIT_A		equ	   200h		; USR 2
	TSS_WAIT_B		equ	   400h		; USR 3
	TSS_WAIT_C		equ	   800h		; USR 4
	TSS_WAIT_D		equ	  1000h		; USR 5
	TSS_WAIT_E		equ	  2000h		; USR 6
	TSS_WAIT_F		equ	  4000h		; USR 7
	TSS_WAIT_G		equ	  8000h		; USR 8 

	TYP_REAL		equ		1
	TYP_NORMAL		equ		2

	TSS			struc
		ttyp	dw  ?		; ۾
		state	dw	?		; ۾
		stk		dd	?		; ڰѱڽ
		pid		dw	?		; PID
		psp		dw	?		; PSPڽ
		dta		dd	?		; DTAڽ
	TSS			ends

; =====================================================================
;	IPC_MESSAGE ubN
; =====================================================================

	MSGCTRL		struc
		nrecv	dw	?					; M pid
		nkeyt	dw	?					; L[l
		nsize	dw	?					; i[AhXTCY
		nposd	dd	?					; i[AhX
		resv	db  6 dup(?)			; U[ü
	MSGCTRL		ends

   	MSGBUF		struc
   		nkeys	dw	?					; L[l
   		nsizb	dw	?					; f[^TCY
   	MSGBUF		ends

; =====================================================================
;	IPC_POSTubN
; =====================================================================

	PRECV_NOWAIT	equ		0			; IPC_PRECV No Wait
	PRECV_WAIT		equ		1			; IPC_PRECV Wait

	@OFFSET_POST	equ		4			; pbindðق̵̾

	POSTTBL		struc
		nkey	dw	?					; IPC_POST L[l
		pcreat	dw	?					; 쐬۾ID
		pbind	dd 	MAX_PTSS dup (?)	; postM۾ID & post Code
	POSTTBL		ends

; =====================================================================
;	exportްްubN
; =====================================================================

	EXPTTBL		struc
		npid	dw	?					; 쐬۾ID
		nkyE	dw	?					; L[l
		adrs	dd	?					; EXPORT ڽ
	EXPTTBL		ends

; =====================================================================
;	^C}[GgubN
; =====================================================================

	TIMERDB		struc
		nkyT	dw	?					; M IPC_POSTL[
		nCdT	dw	?					; M IPC_POSTR[h
		norg	dw	?					; ѱĒliۑpj
		ncur	dw	?					; ϰl
	TIMERDB		ends

; =====================================================================
;	Z}tHubN
; =====================================================================

	SEM_LOCK	equ		1
	SEM_UNLOCK	equ		2
	SEM_NWLOCK	equ		3
	SEM_LOAD	equ		4

	SEMATBL		struc
		nkyS	dw	?					; ̫
		npiS	dw	?					; 쐬 pid
		norS	dw	?					; ̫ől
		ncuS	dw	?					; ̫ݒl
	SEMATBL		ends

; =====================================================================
;	VXeʃ}N
; =====================================================================

display		macro	status
			push	ds
			push	bx
			mov		bx,0a000h
			mov		ds,bx
			mov		byte ptr ds:0f00h,status
			pop		bx
			pop		ds
			endm

putregs		macro	ptregs
			LOCAL	LB1, LB2, LB3
			push	ax
			push	bx
			push	ds
			push	si
			push	cx
			
			push	ptregs

			mov		ax, 0a000h
			mov		ds, ax
			mov		si, 0f00h
			mov		cx, 4
			pop		ax
	LB1:	mov		bx, ax
			shr		ax, 1
			shr		ax, 1
			shr		ax, 1
			shr		ax, 1
			and		bx, 000fh
			cmp		bx, 9
			jle		LB2
			sub		bl, 10
			add		bl, 'A'
			jmp		LB3
	LB2:	add		bl, '0'
	LB3:	mov		byte ptr ds:[si], bl
			inc		si
			inc		si
			loop	LB1
			
			pop		cx
			pop		si
			pop		ds
			pop		bx
			pop		ax
			endm

setregs		macro	adr
			pop		ax
			mov		word ptr es:[di-adr], ax
			endm
