; ***********************************************************************
; *				GENERIC 16bit Realtime Task Monitor						*
; *	    Copyright 1991 - 1998 by Fritz Allrights Reserved.		        *
; *  -----------------------------------------------------------------  *
; *           GENCLIB = b̃C^[tFCX[`S              *
; *                                                                     *
; ***********************************************************************

				include	gen16.inc

; =====================================================================
; GENCLIB - f[^ZOg
; =====================================================================

genclib_data	segment	word public 'DATA'

	stay_msg	db		'GENERIC-16'

genclib_data	ends

; =====================================================================
; GENCLIB - R[hZOg
; =====================================================================

genclib_code	segment	byte public 'CODE'
				assume cs:genclib_code, ds:genclib_data

				public	__checkstay
				public	_CreateThread
				public  _dispatch
				public	_getpid
				public  _kernel_start
				public	_kernel_quit
				public	_getstate
				public	_setstate
				public	_kill
				public  _export
				public  _import
				public	_unexport
				public	_ipc_pinit
				public  _ipc_post
				public  _ipc_precv
				public	_TimerSet
				public	_TimerGet
				public  _ipc_semget
				public	_ipc_semop
				public	_kbd_scan
				public	_kbd_input
				public	_sleep
				public	_modeget
				public	_TimeSlice
				public	_getpinfo
				public  _KillTimer
				public	_msgget
				public  _msgsnd
				public  _msgrcv
				public	_msgdel
				public  _addon
				public  _addoff
				public	_addget

; =======================================================================
; =======================================================================
_addon			proc	far
				push	bp
				mov		bp, sp
				push	bx
				push	cx
				;
				mov		ah, ADDON_REQ
				int		VECT_NO
				;
				pop		cx
				pop		bx
				pop		bp	
				ret
_addon			endp

; =======================================================================
; =======================================================================
_addoff			proc	far
				push	bp
				mov		bp, sp
				push	bx
				push	cx
				;
				mov		ah, ADDOFF_REQ
				int		VECT_NO
				;
				pop		cx
				pop		bx
				pop		bp	
				ret
_addoff			endp

; =======================================================================
; =======================================================================
_addget			proc	far
				push	bp
				mov		bp, sp
				push	bx
				push	cx
				;
				mov		ah, ADDGET_REQ
				int		VECT_NO
				;
				pop		cx
				pop		bx
				pop		bp	
				ret
_addget			endp

; =======================================================================
;   _msgget = IPCbZ[WL[
;   int msgget(int nkey, int nsize) 
;   int  nkey (I ) bZ[WL[
;   int  nsiz (I ) bZ[WXbg̃TCY
; =======================================================================
_msgget			proc	far
				push	bp
				mov		bp, sp
				push	bx
				push	cx
				;
				mov		bx, word ptr ss:[bp+6]
				mov		ah, MSGGET_REQ
				int		VECT_NO
				;
				pop		cx
				pop		bx
				pop		bp	
				ret
_msgget			endp

; =======================================================================
;   _msgsnd = IPCbZ[WM
;	int msgsnd( int nkey, int nsiz, char *data )
;   int   nkey (I ) bZ[WL[
;   int   nsiz (I ) bZ[WXbg̃TCY
;	char *data (I ) bZ[Wf[^
; =======================================================================
_msgsnd			proc	far
				push	bp
				mov		bp, sp
				push	bx
				push	cx
				push	ds
				push	si
				;
				mov		bx,  word ptr ss:[bp+ 6]
				mov		cx,  word ptr ss:[bp+ 8]
				lds		si, dword ptr ss:[bp+10]
				mov		ah, MSGSND_REQ
				int		VECT_NO
				;
				pop		si
				pop		ds
				pop		cx
				pop		bx
				pop		bp	
				ret
_msgsnd			endp

; =======================================================================
;   _msgrcv = IPCbZ[WM
;	int msgrcv( int nkey, int nsiz, char *data )
;   int   nkey (I ) bZ[WL[
;   int   nsiz (I ) bZ[WXbg̃TCY
;	char *data (I ) bZ[Wf[^
; =======================================================================
_msgrcv			proc	far
				push	bp
				mov		bp, sp
				push	bx
				push	cx
				push	ds
				push	si
				;
				mov		bx,  word ptr ss:[bp+ 6]
				mov		cx,  word ptr ss:[bp+ 8]
				lds		si, dword ptr ss:[bp+10]
				mov		ah, MSGRCV_REQ
				int		VECT_NO
				;
				pop		si
				pop		ds
				pop		cx
				pop		bx
				pop		bp	
				ret
_msgrcv			endp

; =======================================================================
; =======================================================================
_msgdel			proc	far
				push	bp
				mov		bp, sp
				push	bx
				push	cx
				;
				mov		bx, word ptr ss:[bp+6]
				mov		ah, MSGDEL_REQ
				int		VECT_NO
				;
				pop		cx
				pop		bx
				pop		bp	
				ret
_msgdel			endp

; =======================================================================
;	_getstate = ۾Ԏ擾
;	int getstate(int pid) ;
;   int  pid (I ) Ώۂohc
; =======================================================================

_getstate		proc	far
				push	bp
				mov		bp, sp
				push	bx
				;
				mov		bx, word ptr ss:[bp+6]
				mov		ah, GETSTS_REQ
				int		VECT_NO
				;
				pop		bx
				pop		bp	
				ret
_getstate		endp

; =======================================================================
;	_setstate = ۾Ԑݒ菈
;	int setstate(int npid, int state)
;   int  pid   (I ) Ώۂohc
;   int  state (I ) ^XN
; =======================================================================

_setstate		proc	far
				push	bp
				mov		bp, sp
				push	bx
				push	cx
				;
				mov		bx, word ptr ss:[bp+6]
				mov		cx, word ptr ss:[bp+8]
				mov		ah, SETSTS_REQ
				int		VECT_NO
				;
				pop		cx
				pop		bx
				pop		bp	
				ret
_setstate		endp
				
; =======================================================================
;	_checkstay = Generic Kernel 풓LmF֐
;	Generic Kernelтɏ풓Ăꍇ 0Ԃ
;	풓ĂȂꍇ -1 Ԃ
;	int _checkstay( void ) ;
; =======================================================================

__checkstay		proc	far
				push	di
				push	si
				push	cx
				push	ds
				push	es
				;
				mov		ax, genclib_data
				mov		ds, ax
				mov		ah, 35h
				mov		al, VECT_NO
				int		21h
				mov		di, bx
				sub		di, 10
				mov  	si, offset stay_msg
				cld
				xor		ax, ax
				mov		cx, 10
				repz	cmpsb
				jnz		chkstyE
				mov		ax, 0
				jmp		chkstyQ
				;
	chkstyE:	mov		ax, -1
	chkstyQ:	pop		es
				pop		ds
				pop		cx
				pop		si
				pop		di
				ret
__checkstay		endp

; =======================================================================
;	CreateThread = Generic Kernelp۾o^
;	Generic Kernel۾o^Bo^Ɏw肷ڽ
;	̐擪(ޯ̧шʒu)łȂ΂ȂȂB
;	pid = CreateThread( pfunction, pstack, size_stack )
;   char far *pfunction (I ) Xbh֐̃AhX
;   char far *pstack    (I ) X^bNAhX
;   int       size_stack(I ) X^bNTCY
; =======================================================================

_CreateThread	proc	far
				push	bp
				mov		bp, sp
				push	ds
				push	si
				push	bx
				push	cx
				push	di
				;
				;	Ұ۾̔Ԓnƽ̱ڽ𓾂
				;
				lds		si, dword ptr ss:[bp+ 6]
				mov		bx, ds
				mov		cx, si
				lds		si, dword ptr ss:[bp+10]
				mov		di, si
				mov		si, ds
				;
				;	۾o^ظĂ𔭍s
				;
				mov		ah, THREAD_REQ
				int		VECT_NO
				;
				pop		di
				pop		cx
				pop		bx
				pop		si
				pop		ds
				pop		bp
				ret
_CreateThread	endp

; =======================================================================
;	dispatch =  YIELD 
;	۾̏Ԃ readyԂɕۂ܂ܑ۾֎s
;	䂸B
;	void dispatch( void ) ;
; =======================================================================

_dispatch		proc	far
				mov		ah, DISPATCH_REQ
				int		VECT_NO
				ret
_dispatch		endp

; =======================================================================
;	getpid = pid擾֐
;	۾ pid ԋp
;	int getpid( void ) ;
; =======================================================================

_getpid			proc	far
				mov		ah, GETPID_REQ
				int		VECT_NO
				ret
_getpid			endp

; =======================================================================
;	kernel_start = Generic Kernel Jnvs
;	void kernel_start( void ) ;
; =======================================================================

_kernel_start	proc	far
				mov		ah, START_REQ
				int		VECT_NO
				ret
_kernel_start	endp

; =======================================================================
;	kernel_quit = Generic Kernel ~vs
;	void kernel_quit( void ) ;
; =======================================================================

_kernel_quit	proc	far
				mov		ah, KQUIT_REQ
				int		VECT_NO
				ret
_kernel_quit	endp

; =======================================================================
;	_ipc_pinit = IPC_POST
;	int ipc_pinit( int nkey ) ;
;   int nkey (I ) Ώۃ|XgL[
; =======================================================================

_ipc_pinit		proc	far
				push	bp
				mov		bp, sp
				push	bx
				mov		bx, word ptr ss:[bp+6]
				mov		ah, IPCPINIT_REQ
				int		VECT_NO
				pop		bx
				pop		bp
				ret
_ipc_pinit		endp

; =======================================================================
;	_ipc_post = IPC_POSTүޑM
;	int ipc_post(int nkey, int post_code) ;
;   int nkey 	  (I ) Ώۃ|XgL[
;   int post_code (I ) |XgR[h
; =======================================================================

_ipc_post		proc	far
				push	bp
				mov		bp, sp
				push	bx
				push	cx
				;
				mov		bx, word ptr ss:[bp+6]
				mov		cx, word ptr ss:[bp+8]
				mov		ah, IPCPOST_REQ
				int		VECT_NO
				;
				pop		cx
				pop		bx
				pop		bp
				ret
_ipc_post		endp

; =======================================================================
;	_ipc_precv = IPC_POSTүގM
;	int ipc_precv(int nkey, int mask);
;   int nkey (I ) Ώۃ|XgL[
;   int mask (I ) M}XN
; =======================================================================

_ipc_precv		proc	far
				push	bp
				mov		bp, sp
				push	bx
				push	cx
				push	dx
				;
				mov		bx, word ptr ss:[bp+ 6]
				mov		cx, word ptr ss:[bp+ 8]
				mov		dx, word ptr ss:[bp+10]
				or		dx, dx
				jz		ipcpr1
				mov		dx, 1
	ipcpr1:		mov		ah, IPCPRECV_REQ
				int		VECT_NO
				;
				pop		dx
				pop		cx
				pop		bx
				pop		bp
				ret
_ipc_precv		endp


; =======================================================================
;	_kill = ۾I
;	void kill(int pid) ;
;   int  pid (I ) Ώۂohc
; =======================================================================

_kill			proc	far
				push	bp
				mov		bp, sp
				;
				mov		bx, word ptr ss:[bp+6]
				mov		ah, KILL_REQ
				int		VECT_NO
				;
				pop		bp
				ret
_kill			endp

; =======================================================================
;	_export = ڽ export 
;	int export(int nkey, char far *addr) ;
;   int       nkey (I ) ΏۃGNX|[ghc
;   char far *addr (I ) ΏۃGNX|[gAhX
; =======================================================================

_export			proc	far
				push	bp
				mov		bp, sp
				push	ds
				push	si
				push	bx
				;
				mov		bx, word  ptr ss:[bp+6]
				les		di, dword ptr ss:[bp+8]				
				mov		ah, EXPORT_REQ
				int		VECT_NO
				;
				pop		bx
				pop		si
				pop		ds
				pop		bp
				ret
_export			endp

; =======================================================================
;	_import = exportް擾
;	char far *import(int nkey) ;
;   int  nkey (I ) ΏۃGNX|[ghc
; =======================================================================

_import			proc	far
				push	bp
				mov		bp, sp
				push	ds
				push	si
				push	bx
				;
				mov		bx, word  ptr ss:[bp+6]
				mov		ah, IMPORT_REQ
				int		VECT_NO
				;
				pop		bx
				pop		si
				pop		ds
				pop		bp
				ret
_import			endp

; =======================================================================
;	_unexport = export
;	int unexport(int nkey) ;
;   int  nkey (I ) ΏۃGNX|[ghc
; =======================================================================

_unexport		proc	far
				push	bp
				mov		bp, sp
				push	ds
				push	si
				push	bx
				;
				mov		bx, word  ptr ss:[bp+6]
				mov		ah, UNEXPORT_REQ
				int		VECT_NO
				;
				pop		bx
				pop		si
				pop		ds
				pop		bp
				ret
_unexport		endp

; =======================================================================
;	_TimerSet = ϰݒ菈
;	int TimerSet(int elem, int tick, int post_key, int post_code) ;
;   int  elem  		(I ) Gghc
;   int  tick  		(I ) ^C}`bN
;   int  post_key	(I ) ^CAEg̃|XgL[
;   int  post_code	(I ) ^CAEg̃|XgR[h
; =======================================================================

_TimerSet		proc	far
				push	bp
				mov		bp, sp
				push	di
				push	bx
				push	cx
				push	dx
				;
				mov		di, word ptr ss:[bp +  6]
				mov		bx, word ptr ss:[bp +  8]
				mov		cx, word ptr ss:[bp + 10]
				mov		dx, word ptr ss:[bp + 12]
				mov		ah, SETTIMER_REQ
				int		VECT_NO
				;
				pop		dx
				pop		cx
				pop		bx
				pop		di
				pop		bp
				ret
_TimerSet		endp

; =======================================================================
;	_TimerGet = Ұď擾
;	int TimerGet(int elemid, struct _tmgetinf far *dst ) ;
;   int  				  elemid (I )	Ώۃ^C}[hc
;   struct _tmgetinf far *dst 	 ( O) 	^C}[i[GA
; =======================================================================

_TimerGet		proc	far
				push	bp
				mov		bp, sp
				push	es
				push	di
				push	bx
				;
				mov		bx,  word ptr ss:[bp+6]
				les		di, dword ptr ss:[bp+8]
				mov		ah, GETTIMER_REQ
				int		VECT_NO
				;
				pop		bx
				pop		di
				pop		es
				pop		bp
				ret
_TimerGet		endp

; =======================================================================
;	_ipc_semget = ̫
;	int ipc_semget(int nkey, int maxnum) ;
;   int  nkey  (I )	Z}tHL[
;   int  maxnum(I ) őԂ萔
; =======================================================================

_ipc_semget		proc	far
				push	bp
				mov		bp, sp
				push	bx
				push	cx
				;
				mov		bx, word ptr ss:[bp + 6]
				mov		cx, word ptr ss:[bp + 8]
				mov		ah, SEMGET_REQ
				int		VECT_NO
				;
				pop		cx
				pop		bx
				pop		bp
				ret
_ipc_semget		endp

; =======================================================================
;	_ipc_semop = ̫쏈
;	int ipc_semop(int nkey, int cmd) ;
;   int  nkey  (I )	Z}tHL[
;   int  cmd   (I )	Z}tHR[h
; =======================================================================

_ipc_semop		proc	far
				push	bp
				mov		bp, sp
				push	bx
				push	cx
				;
				mov		bx, word ptr ss:[bp + 6]
				mov		cx, word ptr ss:[bp + 8]
				mov		ah, SEMOPE_REQ
				int		VECT_NO
				;
				pop		cx
				pop		bx
				pop		bp
				ret
_ipc_semop		endp

; =======================================================================
;	_kbd_scan = ް޽ðǂݍݏ
;	int kbd_scan( void ) ;
; =======================================================================

_kbd_scan		proc	far

		if PC_9801
				push	bx
				mov		ah, 1
				int		18h
				or		bh, bh
				jz		kbds0
				mov		ax, 1
				jmp		kbds1
		kbds0:	xor		ax, ax
		kbds1:	pop		bx
		else
				mov		ah, 1
				int		16h
				jz		kbds0
				mov		ax, 1
				jmp		kbds1
		kbds0:	xor		ax, ax
		kbds1:	ret
		endif
				ret
_kbd_scan		endp

; =======================================================================
;	_kbd_input = P͏
;	int kbd_input( void ) ;
; =======================================================================

_kbd_input		proc	far
				mov		ah, 7
				int		21h
				xor		ah, ah
				ret
_kbd_input		endp

; =======================================================================
; vZXx
; void sleep( ncnt )
; int  ncnt  (I ) x
; =======================================================================

_sleep			proc	far
				push	bp
				mov		bp, sp
				push	bx
				;
				mov		bx, word ptr ss:[bp+6]
				mov		ah, SLEEP_REQ
				int		VECT_NO
				;
				pop		bx
				pop		bp
				ret
_sleep			endp

; =======================================================================
; J[lݒl擾
; int modeget( buf )
; struct	_modgetbuf *buf  ( O) J[lݒli[obt@
; =======================================================================

_modeget		proc	far
				push	bp
				mov		bp, sp
				push	es
				push	di
				
				les		di, dword ptr ss:[bp+6]
				mov		ah, MODGET_REQ
				int		VECT_NO
				
				pop		di
				pop		es
				pop		bp
				ret
_modeget		endp

; =======================================================================
; ^CXCXLݒ
; int TimeSlice( flag )
; int  flag  (I ) ^CXCXLtO
;                 1 = Time Slice Start
;                 0 = Time Slice Stop
; =======================================================================

_TimeSlice		proc	far
				push	bp
				mov		bp, sp
				push	bx

				mov		bx, word ptr ss:[bp+6]
				or		bx, bx
				jz		tmsl1
				mov		bx, 1
	tmsl1:		mov		ah, TMSLICE_REQ
				int		VECT_NO
				
				pop		bx
				pop		bp
				ret
_TimeSlice		endp

; =======================================================================
; vZX擾
; int getpinfo( pid, buf )
; int  				pid   (I ) ΏۃvZXhc
; struct  _pinfo   *buf   ( O) vZXi[obt@
; =======================================================================

_getpinfo		proc	far
				push	bp
				mov		bp, sp
				push	es
				push	di
				
				mov		bx,  word ptr ss:[bp+6]
				les		di, dword ptr ss:[bp+8]
				mov		ah, GETPINF_REQ
				int		VECT_NO
				
				pop		di
				pop		es
				pop		bp
				ret
_getpinfo		endp

; =======================================================================
; ^C}[폜
; int KillTimer( int elem )
; =======================================================================

_KillTimer      proc    far
				push	bp
				mov		bp, sp
				push	bx
				;
				mov		bx, word ptr ss:[bp+6]
				mov		ah, KILLT_REQ
				int		VECT_NO
				;
				pop		bx
				pop		bp
				ret
_KillTimer      endp

genclib_code	ends
				end

